﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridDynamicColumns
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        string currentFieldInGroup = "";

        public MainWindow()
        {
            InitializeComponent();
        }

        public StaffMemberViewModel ViewModel
        {
            get { return this.DataContext as StaffMemberViewModel; }
        }

        private void xamDataGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            //a cheat to get the number of columns to create.
            var staffMember = this.ViewModel.StaffMembers.First();

            for (Int32 i = 0; i < staffMember.Periods.Count; i++)
            {
                var field = new UnboundField
                {
                    Name = staffMember.Periods[i].Title,
                    BindingMode = BindingMode.TwoWay,
                    BindingPath = new PropertyPath(String.Format("Periods[{0}].Hours", i))
                };

                field.Settings.EditAsType = typeof(Int32);
                field.Settings.EditorStyle = (Style)Resources["HoursFieldStyle"];

                e.FieldLayout.Fields.Add(field);
            }
        }

        private void XamDataGrid_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            if(e.Groups.Length > 0)
                currentFieldInGroup = e.Groups[e.Groups.Length - 1].Field.Label.ToString();

               
            if (currentFieldInGroup == "Department")
            {
                if (xdg.FieldLayouts[0].Fields["Department"].Visibility == Visibility.Visible)
                {
                    xdg.FieldLayouts[0].Fields["Department"].Visibility =
                    Visibility.Collapsed;
                }
                else
                {
                    xdg.FieldLayouts[0].Fields["Department"].Visibility =
                    Visibility.Visible;
                }
                
            }
        }
    }
}
